# All Cluster Statuses

Launch stage: GA

`GET /api/2.0/libraries/all-cluster-statuses`

Get the status of all libraries on all clusters. A status is returned for all libraries installed on this cluster
 via the API or the libraries UI.

API scopes: libraries

## Returns

- `statuses` (array of object, optional)
  A list of cluster statuses.
  - `cluster_id` (string, optional)
    Unique identifier for the cluster.
  - `library_statuses` (array of object, optional)
    Status of all libraries on the cluster.
    - `library` (object, optional)
      Unique identifier for the library.
      - `jar` (string, required)
        URI of the JAR library to install. Supported URIs include Workspace paths, Unity Catalog Volumes paths, and S3 URIs.
         For example: `{ "jar": "/Workspace/path/to/library.jar" }`, `{ "jar" : "/Volumes/path/to/library.jar" }` or
         `{ "jar": "s3://my-bucket/library.jar" }`.
         If S3 is used, please make sure the cluster has read access on the library. You may need to
         launch the cluster with an IAM role to access the S3 URI.
        **Azure:** URI of the JAR library to install. Supported URIs include Workspace paths, Unity Catalog Volumes paths, and ADLS URIs.
        For example: `{ "jar": "/Workspace/path/to/library.jar" }`, `{ "jar" : "/Volumes/path/to/library.jar" }` or
        `{ "jar": "abfss://my-bucket/library.jar" }`.
        If ADLS is used, please make sure the cluster has read access on the library. You may need to
        launch the cluster with a Microsoft Entra ID service principal to access the ADLS URI.
        **GCP:** URI of the jar library to be installed. Supported URIs include Workspace path, UC Volumes path, and GCS URIs.
        For example: `{ "jar": "/Workspace/path/to/library.jar" }`, `{ "jar" : "/Volumes/path/to/library.jar" }` or
        `{ "jar": "gs://my-bucket/library.jar" }`.
        If GCS is used, please make sure the cluster has read access on the library. You may need to
        launch the cluster with an IAM service account to access the GCS URI.
      - `egg` (string, required)
        Deprecated. URI of the egg library to install. Installing Python egg files is deprecated and is not supported in Databricks Runtime 14.0 and above.
      - `pypi` (object, required)
        Specification of a PyPi library to be installed. For example:
         `{ "package": "simplejson" }`
      - `maven` (object, required)
        Specification of a maven library to be installed. For example:
         `{ "coordinates": "org.jsoup:jsoup:1.7.2" }`
      - `cran` (object, required)
        Specification of a CRAN library to be installed as part of the library
      - `whl` (string, required)
        URI of the wheel library to install. Supported URIs include Workspace paths, Unity Catalog Volumes paths, and S3 URIs.
         For example: `{ "whl": "/Workspace/path/to/library.whl" }`, `{ "whl" : "/Volumes/path/to/library.whl" }` or
         `{ "whl": "s3://my-bucket/library.whl" }`.
         If S3 is used, please make sure the cluster has read access on the library. You may need to
         launch the cluster with an IAM role to access the S3 URI.
        **Azure:** URI of the wheel library to install. Supported URIs include Workspace paths, Unity Catalog Volumes paths, and ADLS URIs.
        For example: `{ "whl": "/Workspace/path/to/library.whl" }`, `{ "whl" : "/Volumes/path/to/library.whl" }` or
        `{ "whl": "abfss://my-bucket/library.whl" }`.
        If ADLS is used, please make sure the cluster has read access on the library. You may need to
        launch the cluster with a Microsoft Entra ID service principal to access the ADLS URI.
        **GCP:** URI of the wheel library to be installed. Supported URIs include Workspace path, UC Volumes path, and GCS URIs.
        For example: `{ "whl": "/Workspace/path/to/library.whl" }`, `{ "whl" : "/Volumes/path/to/library.whl" }` or
        `{ "whl": "gs://my-bucket/library.egg" }`.
        If GCS is used, please make sure the cluster has read access on the library. You may need to
        launch the cluster with an IAM service account to access the GCS URI.
      - `requirements` (string, required)
        URI of the requirements.txt file to install. Only Workspace paths and Unity Catalog Volumes paths are supported.
         For example: `{ "requirements": "/Workspace/path/to/requirements.txt" }` or `{ "requirements" : "/Volumes/path/to/requirements.txt" }`
    - `status` (string, optional)
      Status of installing the library on the cluster.
      Possible values: `PENDING`, `RESOLVING`, `INSTALLING`, `INSTALLED`, `FAILED`, `UNINSTALL_ON_RESTART`, `SKIPPED`, `RESTORED`
    - `messages` (array of string, optional)
      All the info and warning messages that have occurred so far for this library.
    - `is_library_for_all_clusters` (boolean, optional)
      Whether the library was set to be installed on all clusters via the libraries UI.

## Response

```json
{
  "statuses": [
    {
      "cluster_id": "1234-56789-abcde",
      "library_statuses": [
        {
          "is_library_for_all_clusters": false,
          "library": {
            "pypi": {
              "package": "numpy",
              "repo": "http://my-pypi-repo.com"
            }
          },
          "status": "INSTALLED"
        },
        {
          "is_library_for_all_clusters": false,
          "library": {
            "jar": "/Workspace/path/to/library.jar"
          },
          "status": "INSTALLED"
        }
      ]
    },
    {
      "cluster_id": "234-567890-fghij",
      "library_statuses": [
        {
          "is_library_for_all_clusters": false,
          "library": {
            "whl": "/Workspace/path/to/library.whl"
          },
          "status": "PENDING"
        }
      ]
    }
  ]
}
```

